//
//  AppDelegate.swift
//  customWindowTest
//
//  Created by Tobias Dunkel on 03.11.17.
//  Copyright © 2017 Tobias Dunkel. All rights reserved.
//

import Cocoa

@NSApplicationMain
class AppDelegate: NSObject, NSApplicationDelegate, NSWindowDelegate {

    @IBOutlet weak var window: NSWindow!

    @IBOutlet weak var myStackView: NSStackView!
    @IBOutlet weak var mySplitView: NSSplitView!
    
    @IBOutlet weak var playlistBox: NSBox!
    @IBOutlet weak var playlistView: NSView!
    
    @IBAction func togglePlaylistAction(_ sender: Any) {
        if !playlistBox.isHidden {
            playlistBox.isHidden = true
        } else {
            playlistBox.isHidden = false
        }
    }
    
    @IBAction func menuFullscreenAction(_ sender: Any) {
        window.toggleFullScreen(nil)
    }
    
    @IBAction func menuZoomAction(_ sender: Any) {
        window.zoom(nil)
    }
    
    @IBAction func menuMinimizeAction(_ sender: Any) {
        window.miniaturize(nil)
    }
    
    
    func applicationDidFinishLaunching(_ aNotification: Notification) {
                
        window.contentView?.wantsLayer = true
        myStackView.wantsLayer = true
        mySplitView.wantsLayer = true
        
        window.isOpaque = false
        window.backgroundColor = NSColor.clear
        window.isMovableByWindowBackground = true
        
        window.contentView = mySplitView
        window.styleMask = [.borderless, .resizable, .miniaturizable, .closable]
        window.hasShadow = false

        //window.titleVisibility = .hidden
        //window.titlebarAppearsTransparent = true
        
    }
    
    func windowDidResize(_ notification: Notification) {
        NSLog("call -> window did resize")
    }
    
    func applicationWillTerminate(_ aNotification: Notification) {
        // Insert code here to tear down your application
    }

}


class MysplitViewController: NSSplitViewController {
    override func splitViewDidResizeSubviews(_ notification: Notification) {
        (NSApp.delegate as! AppDelegate).windowDidResize(notification)
    }
}


class MySplitView: NSSplitView {
    override var dividerThickness: CGFloat {
        get { return 5}
    }
    override var dividerColor: NSColor {
        get { return NSColor(calibratedWhite: 0, alpha: 0.001)}
    }
}
